import csv
import numpy as np
import matplotlib.pyplot as plt
from math import sqrt



     # Les fichiers csv doivent être stockés dans le même repertoire que les fichiers python sauvegardés



    #********************************************************************************************************

    #****************  Code pour formater un fichier csv en une liste utilisable par Python  ****************

    #********************************************************************************************************


def List_extract(p,n,Liste_de_nbre):
    List_aux1 = []
    List_ext1 = []
    N = len(Liste_de_nbre)

    for i in range(p,p+n):
        List_aux1 = List_aux1 + [Liste_de_nbre[i]]
    List_ext1 = List_aux1
    return List_ext1


     # Code pour convertir le fichier Temps.csv en fichier utilisable par Python à fournir aux élèves

with open("Temps.csv") as f:
    Temps = list(csv.reader(f))
var_list = []
list_tot = []
for i in range(0,len(Temps)):
    var_list = Temps[i]
    var_list = list(map(float,var_list))
    list_tot = list_tot + var_list
Temps = list_tot

Temps1 = List_extract(10000, 36169, list_tot)
print(len(Temps1))


     # Code pour convertir le fichier Temperature.csv en fichier utilisable par Python à fournir aux élèves

with open("Temperature.csv") as f:
    Temperature = list(csv.reader(f))
var_list = []
list_tot = []
for i in range(0,len(Temperature)):
    var_list = Temperature[i]
    var_list = list(map(float, var_list))
    list_tot = list_tot + var_list
Temperature = list_tot

Temperature1 = List_extract(10000, 36169, list_tot)
print(len(Temperature1))


     # Code pour convertir le fichier Pression.csv en fichier utilisable par Python à fournir aux élèves

with open("Pression.csv") as f:
    Pression = list(csv.reader(f))
var_list = []
list_tot = []
for i in range(0,len(Pression)):
    var_list = Pression[i]
    var_list = list(map(float, var_list))
    list_tot = list_tot + var_list
Pression = list_tot
print(len(Pression))

Pression1 = List_extract(13000, 36169, list_tot)
print(len(Pression1))


    #********************************************************************************************************

    #*******************  Code pour convertir un temps en h:min:s en heure décimale   ***********************

    #********************************************************************************************************


def Conv_Dec_Hms(valeur):

    global heure
    global minute
    global seconde

    heure    = int(valeur)
    minute   = int((valeur-heure)*60)
    seconde  = int(((valeur -heure)*60-minute)*60)


    #********************************************************************************************************

    #******************  Code pour déterminer le nombre de Dust potentiel et leur rang  *********************

    #********************************************************************************************************



def Dust_rank(List,ecart):

    Nbre_Dust = 0
    List_rang = []

    for i in range(len(List)-1):
        if abs(List[i]-List[i+1])>ecart:
            Nbre_Dust = Nbre_Dust + 1
            List_rang = List_rang + [i]
    print('\n')
    print("The estimated Dust Devil number is:",Nbre_Dust)
    print("(Offset more than",ecart,"Pa between two consecutives pressure)")
    print('\n')

    aux=0
    for i in List_rang:
        Conv_Dec_Hms(Temps[i])
        print("Time and rank of the Dust Devil arrived at :",heure," h ",minute," min ",seconde," s ", ", at the rank : ", List_rang[aux])
        print('\n')
        aux=aux+1

    print("We need to display graph around this rank to confirm the Dust Devil.")
    print("For that, we need to use the function Graph_around_dust with the ranks found previously.")



    #********************************************************************************************************

    #*******************  Code pour tracer la courbe centrée autour du Dust potentiel  **********************

    #********************************************************************************************************



def Graph_around_dust(rang):
    global Temps_around_dust
    global Temperature_around_dust
    global Pression_around_dust

    Temps_around_dust = List_extract(rang-50,100,Temps)
    Temperature_around_dust = List_extract(rang-50,100,Temperature)
    Pression_around_dust = List_extract(rang-50,100,Pression)

    plt.close()
    plt.clf()

    plt.subplot(211)
    plt.plot(Temps_around_dust, Pression_around_dust, "b", linewidth=1)
    plt.ylabel('Pression')
    plt.axis([min(Temps_around_dust), max(Temps_around_dust), min(Pression_around_dust)-1, max(Pression_around_dust)+1])

    plt.title("Pression and Temperature graphs around Dust Devil found :")

    plt.subplot(212)
    plt.plot(Temps_around_dust, Temperature_around_dust, "r", linewidth=1)
    plt.xlabel('Decimal Time in hours')
    plt.ylabel('Temperature')
    plt.axis([min(Temps_around_dust), max(Temps_around_dust) , min(Temperature_around_dust)-1, max(Temperature_around_dust)+1])

    plt.show()




    #********************************************************************************************************

    #***************  Code pour calculer la moyenne d'une liste de nombre avec la fonction SUM  *************

    #********************************************************************************************************



def Average(Liste_de_nbre):
    moyenne = sum(Liste_de_nbre)/(len(Liste_de_nbre))
    return moyenne


    #********************************************************************************************************

    #***************  Code pour calculer la moyenne d'une liste de nombre sans la fonction SUM  *************

    #********************************************************************************************************


def moyenne_modifiee(Liste_de_nbre):

    Somme_aux = 0
    N = len(Liste_de_nbre)

    for i in range(N):
        Somme_aux = Somme_aux + Liste_de_nbre[i]

    return Somme_aux/N



    #********************************************************************************************************

    #*************  Code pour extraire une liste de taille donnée commençant à un rang donné  ***************

    #********************************************************************************************************



def List_extract(p,n,Liste_de_nbre):
    List_aux1 = []
    List_ext1 = []
    N = len(Liste_de_nbre)

    for i in range(p,p+n):
        List_aux1 = List_aux1 + [Liste_de_nbre[i]]
    List_ext1 = List_aux1
    return List_ext1



    #********************************************************************************************************

    #*********  Code permettant d'obtenir une liste de moyenne mobile sur n valeurs d'une liste  ************

    #********************************************************************************************************



def List_Moving_Average(n,Liste):
    global List_ext2
    List_aux2 = []
    List_ext2 = []

    N = len(Liste)

    for i in range(0,N-n+1):
        List_aux2 = List_aux2 + [Average(List_extract(i,n,Liste))]
    List_ext2 = List_aux2

    return List_ext2




    #********************************************************************************************************

    #************  Code pour calculer la moyenne mobile sur n valeurs et afficher les courbes  **************

    #********************************************************************************************************



def Moving_Average(n, Liste1, Liste2, Liste3):
    global Temps_moy
    global Temperature_moy
    global Pression_moy

    Temps_moy = List_Moving_Average(n, Liste1)
    Temperature_moy = List_Moving_Average(n, Liste2)
    Pression_moy = List_Moving_Average(n, Liste3)

    plt.close()
    plt.clf()

    plt.subplot(211)
    plt.plot(Temps_moy, Pression_moy, "b", linewidth=1)

    plt.ylabel('Pressure')
    plt.axis([min(Temps_moy), max(Temps_moy), min(Pression_moy)-1, max(Pression_moy)+1])

    plt.title("Moving average on a subset size of " + str(n) + " values")

    plt.subplot(212)
    plt.plot(Temps_moy, Temperature_moy, "r", linewidth=1)
    plt.xlabel('Decimal Time in hours')
    plt.ylabel('Temperature')
    plt.axis([min(Temps_moy), max(Temps_moy) , min(Temperature_moy)-1, max(Temperature_moy)+1])

    plt.show()



    #********************************************************************************************************

    #************************  Code pour calculer l'equation des moindres carrés  ***************************

    #********************************************************************************************************



def Least_squares_equation(n,p):

     # Code permettant de fermer la fenêtre de graphe précédente

    plt.close()

    Temperature = List_extract(n, p-n, Temperature_moy)
    Pression = List_extract(n, p-n, Pression_moy)

    calc_T = 0
    calc_P = 0
    for i in range(len(Temperature)):   # la commande len prend en attribut une liste et renvoie sa longueur
        calc_T = calc_T + Temperature[i]
        calc_P = calc_P + Pression[i]
    moyenne_T=calc_T/(len(Temperature))
    moyenne_P=calc_P/(len(Pression))

      # Code donnant la liste des ecarts entre les Temperatures respectifs et la moyenne des Temperatures

    list_ecart_T = []
    for i in range(len(Temperature)):
        list_ecart_T = list_ecart_T + [Temperature[i]-moyenne_T]
    ecart_T = list_ecart_T

      # Code donnant la liste des ecarts entre les Pressions respectives et la moyenne des Temperature

    list_ecart_P = []
    for i in range(len(Pression)):
        list_ecart_P = list_ecart_P + [Pression[i]-moyenne_P]
    ecart_P = list_ecart_P

      # Code donnant la liste des carrés des ecarts entre les Temperatures respectifs et la moyenne des Temperature

    list_carre_ecart_T = []
    for i in range(len(Temperature)):
      # Code en reprenant les listes définies à la ligne 50, qui necessite une numerotation d'indice démarrant à 0 donc mettre i-n

        list_carre_ecart_T = list_carre_ecart_T + [(ecart_T[i])**2]

      # Code en calculant direct avec les listes Pression de depart
      # list_carre_ecart_P = list_carre_ecart_P + [(Pression[i]-moyenne_P)**2]

    carre_ecart_T = list_carre_ecart_T

      # Code donnant la liste des carrés des ecarts entre les Pression respectives et la moyenne des Pressions

    list_carre_ecart_P = []
    for i in range(len(Pression)):

      # list_carre_ecart_P = list_carre_ecart_P + [(Pression[i]-moyenne_P)**2]

       list_carre_ecart_P = list_carre_ecart_P + [(ecart_P[i])**2]
    carre_ecart_P = list_carre_ecart_P

      # Code donnant la liste des produits des ecarts_T et ecart_P

    list_produit_ecart = []
    for i in range(len(Pression)):

      # list_produit_ecart = list_produit_ecart + [(Temperature[i]-moyenne_T)*(Pression[i]-moyenne_P)]

        list_produit_ecart = list_produit_ecart + [(ecart_T[i])*(ecart_P[i])]
    produit_ecart = list_produit_ecart

      # Code donnant sigma_T_P

    sigma_T_P=sum(produit_ecart)/(len(Temperature))

      # Code donnant sigma_T

    sigma_T = sqrt(sum(carre_ecart_T)/(len(Temperature)))

      # Code donnant sigma_P

    sigma_P = sqrt(sum(carre_ecart_P)/(len(Temperature)))

      # Code donnant le calcul du coefficient de correlation r

    r = sigma_T_P/(sigma_T*sigma_P)
    print()                                 # Code pour avoir un saut de ligne
    print('The correlation coefficient r is :',round(r,3))
    print('The coefficient r² is :',round(r*r,3))
    print()

      # Code donnant les coefficients de la droite de regression a et b sous condition d'une bonne corrélation linéaire entre P et T

    if r*r>0.75:
        print('There is a good linear correlation between pressure P and temperatures T.')
        b=round(sigma_T_P/(sigma_T**2),2)
        a=round(moyenne_P-b*moyenne_T,2)
        print()
        print("The equation of the regression line is : P=",b,"T","+",a)

      # Code permettant d'afficher un nuage de points entre les Temperatures et les Pressions moyennées

        # plt.clf()

        x = np.array(Temperature)
        y = np.array(Pression)

        plt.xlabel('Moving Average of Temperature')
        plt.ylabel('Moving Average of Pressure')

        plt.scatter(x, y, s=5, marker = '+')

      # Code permettant d'afficher la droite des moindres carrés entre les Temperatures et les Pressions moyennées

        T = np.array(Temperature)
        P = b * T + a
        plt.plot(T,P,"r--")

        plt.show()

    else:
        print('There is a bad linear correlation between pressure P and temperatures T.')

        # plt.clf()


        x = np.array(Temperature)
        y = np.array(Pression)

        plt.xlabel('Moving Average of Temperature')
        plt.ylabel('Moving Average of Pressure')

        plt.scatter(x, y, s=5, marker = '+')

        plt.show()





